local B = CBW_Battle

B.AttackText = function(player)
	local pflags = player.pflags
	local ability = player.charability
	local ability2 = player.charability2
	local actiontype = player.actiontype
	local actionstate = player.actionstate
	local sflags = player.charflags
	//Priority
	if player.powers[pw_invulnerability] or player.powers[pw_super] then return end
	if (player.powers[pw_shield] == SH_ARMAGEDDON) and pflags&PF_SHIELDABILITY then return end
	//Ability specific
	if player.powers[pw_shield] == SH_ATTRACT and pflags&PF_SHIELDABILITY then return "homing attack" end
	if actiontype == CA_THOK and actionstate == 1 then return "ground pound" end
	if actiontype == CA_THOK and actionstate == 2 then return "super jump" end
	if ability == CA_THOK and pflags&PF_THOKKED and not(pflags&PF_SHIELDABILITY) then return "speed thok" end
	if ability == CA_FLY and pflags&PF_THOKKED and not(pflags&PF_SHIELDABILITY) then return "propeller attack" end
	if actiontype == CA_GLIDEANDCLIMB and actionstate == 2 then return "drill dive" end
	if ability == CA_GLIDEANDCLIMB and pflags&PF_GLIDING then return "gliding fists" end
	if ability == CA_TWINSPIN and player.panim == PA_ABILITY then return "twin spin attack" end
	if ability2 == CA2_MELEE and player.panim == PA_ABILITY2 then return "hammer thrust" end
	if ability == CA_BOUNCE and PF_BOUNCING then return "tail bounce" end
	if player.dashmode > TICRATE*3 then return "dash attack" end
	//General
	if pflags&PF_JUMPED and not(pflags&PF_NOJUMPDAMAGE) then return "jumping spin attack" end
	if pflags&PF_SPINNING then return "spin attack" end
	if pflags&PF_JUMPED and sflags&SF_STOMPDAMAGE then return "jump attack" end
	//Default
	return "attack"
end

B.CustomHurtMessage = function(player,source,bullettext,hurttext,killtext)
	//Defining playertext
	local playertext = player.name
	if G_GametypeHasTeams() then
		if player.ctfteam == 1 then playertext = "\x85"..$.."\x80" end
		if player.ctfteam == 2 then playertext = "\x84"..$.."\x80" end
	end
	//Defining sourcetext
	local sourcetext
	if source and source.player then 
		sourcetext = source.player.name
		if G_GametypeHasTeams() then
			if source.player.ctfteam == 1 then sourcetext = "\x85"..$.."\x80" end
			if source.player.ctfteam == 2 then sourcetext = "\x84"..$.."\x80" end
		end
	end
	//Defining damagetext
	if hurttext == nil then hurttext = "hit" end
	if killtext == nil then killtext = "killed" end
	//Which do we choose?
	local choosehurttext
	if (player.mo.health) then
		choosehurttext = hurttext
	else
		choosehurttext = killtext
	end
	local text = ""
	//If no sourceplayer
	if source == nil then
		text = playertext.." was "..choosehurttext
		if (bullettext) then
			text = $.." by "..bullettext.."."
		end
	//If attacking player
	else
		text = sourcetext
		if (bullettext) then
			text = $.."'s "..bullettext
		end	
		text = $.." "..choosehurttext.." "..playertext.."."
	end
	return text
end

