local B = CBW_Battle

B.InitPlayer = function(player)
	//Action variables
	player.actiontype = 0
	player.actionrings = 0
	player.action2rings = 0
	player.actiontime = 0
	player.actionstate = 0
	player.actioncooldown = 2
	player.actionallowed = true
	player.actiontext = nil
	player.actiontextflags = 0
	player.action2text = nil
	player.action2textflags = 0
	player.charmed = false
	player.charmedtime = 0
	player.backdraft = 0
	player.spendrings = 0
	player.disableringslinger = false
	player.iseggrobo = false
	player.capturing = false
	player.captureamount = 0
	player.gotflagdebuff = false
	player.pushed_creditplr = nil
	player.pushed_credittime = 0
	player.shieldstock = 0
	player.shieldmax = 2
	if player.mo then
		player.charflags = skins[player.mo.skin].flags
	end
	if player.autoaim == nil then
		player.autoaim = 1
	end
end

B.ResetPlayerProperties = function(player,jumped,thokked)
	local mo = player.mo
	if not(mo) then return end
	//Reset pflags
	local pflags = player.pflags&~(PF_GLIDING|PF_BOUNCING)
	if jumped == true and not(mo.state == S_PLAY_SPRING) then
		pflags = $|PF_JUMPED&~(PF_STARTJUMP|PF_NOJUMPDAMAGE)
		mo.state = S_PLAY_ROLL
	elseif jumped == false then
		pflags = $&~(PF_JUMPED|PF_SPINNING)
		if not(P_IsObjectOnGround(mo)) and not(P_PlayerInPain(player)) then
			mo.state = S_PLAY_FALL
		end
	end
	if thokked == true then pflags = $|PF_THOKKED
	elseif thokked == false then pflags = $&~PF_THOKKED
	end
	player.pflags = pflags
	//Reset other variables
	local skin = skins[mo.skin]
	mo.flags = $&~(MF_NOCLIPTHING)
	mo.flags2 = $&~(MF2_DONTDRAW)
	player.charability = skin.ability
	player.charability2 = skin.ability2
	player.normalspeed = skin.normalspeed
	player.thrustfactor = skin.thrustfactor
	player.climbing = 0
	player.secondjump = 0
	player.actionstate = 0
	player.actiontime = 0
	if mo.rollangle != 0 then 
		mo.rollangle = 0
		player.drawangle = mo.angle
	end
end

B.UpdatePlayerTrueMobjs = function()
	//Get counts
	local needtrue = 0
	for player in players.iterate() 
		if not(player.truemo) or not(player.truemo.valid) then
			player.truemo = nil
			needtrue = $+1
		end
	end
	//Iterate
	for mobj in mobjs.iterate()
		if mobj.player and not(mobj.player.truemo) then
			mobj.player.truemo = mobj
			needtrue = $-1
			if not(needtrue) then return true end
		end
	end
	return false
end

B.PlayerButtonPressed = function(player,button,held,stasis)
		if not(player.cmd.buttons&button) then return false end
		if held == true and not(player.buttonhistory&button) then return false end
		if held == false and player.buttonhistory&button then return false end
		if(stasis) then return false end
		return true
end

B.MyTeam = function(player,myplayer)
	//Check yourself before you wreck yourself
	if myplayer == player then return true end
	//FriendlyFire
	if CV_FindVar("friendlyfire").value then
		return false
	end
	//CTF checks
	if G_GametypeHasTeams() then
		if player.ctfteam == myplayer.ctfteam then return true
		else return false
		end
	end
	//Tag checks
	if B.TagGametype() then
		if player.pflags&PF_TAGIT == myplayer.pflags&PF_TAGIT then return true
		else return false
		end
	end
	//Battle check
	if (B.BattleGametype() or G_RingSlingerGametype()) and not(G_GametypeHasTeams()) then
		return false
	end
	//default
	return true
end

