local B = CBW_Battle
local CV = B.Console

B.CharShieldMax["sonic"] = 1
B.CharShieldMax["tails"] = 2
B.CharShieldMax["knuckles"] = 2
B.CharShieldMax["amy"] = 1
B.CharShieldMax["fang"] = 2
B.CharShieldMax["metalsonic"] = 3

B.ShieldAbility = function(player)
	local mo = player.mo
	local shieldability = (player.pflags&PF_SHIELDABILITY)
	local shield = player.powers[pw_shield]&SH_NOSTACK
	local jumpstate = player.pflags&PF_JUMPED and not(player.pflags&PF_NOJUMPDAMAGE)
	if shieldability and (shield == SH_FLAMEAURA or shield == SH_FLAMEWRAP) and not jumpstate then
		player.pflags = ($|PF_JUMPED)&~PF_NOJUMPDAMAGE
		mo.state = S_PLAY_ROLL
	end
end

//Shield Spawn

function A_GiveShield(actor,var1,var2)
	if not(actor.target and actor.target.player) then return end
	local player = actor.target.player
	if CV.ShieldStock.value and (gametyperules&GTR_PITYSHIELD)
-- 		and player.powers[pw_shield]&SH_NOSTACK then
-- 		player.shieldstock = min(player.shieldmax,$+1)
		player.shieldstock = player.shieldmax
	end
-- 	return
-- 	super(actor,var1,var2) //Not doing this since lua calls aren't agreeing with it
	P_SwitchShield(player, var1)
	S_StartSound(player.mo, actor.info.seesound)
end

B.ShieldMax = function(player)
	if not(CV.ShieldStock.value) then return end	
-- 	if (player.shieldstock and player.shieldmax)
		//Get shield max
		local skinmax = B.CharShieldMax[player.truemo.skin]	
		if skinmax == nil then
			player.shieldmax = 2
		else
			player.shieldmax = skinmax
		end
		//Force limit shield stock max
		if player.shieldstock > player.shieldmax then
			player.shieldstock = player.shieldmax
		end
-- 	end
end

B.ShieldStock = function(player)
	if not(CV.ShieldStock.value) then return end	
	//Go no further if we're not in the game
	if (player.spectator) then return end
	player.pity = 0 //We don't use this
	
	//Use shield stock
	local currentshield = player.powers[pw_shield]&SH_NOSTACK

	//Do we still not have a shield for some reason, even though we have stock? Fix that.
	if not(P_PlayerInPain(player)) and not(currentshield) and player.shieldstock and not(player.charmed) then
		player.shieldstock = $-1
		P_SwitchShield(player, 1)
		S_StartSound(player.mo,sfx_shield)
	end
	
end

B.ShieldColor = function(mo,owner)
	if not(owner and owner.valid and owner.player and owner.player.valid) then return nil end
	mo.color = owner.player.skincolor
	mo.colorized = true
end

B.SpawnWithShield = function(player)
	if gametyperules&GTR_PITYSHIELD and not(player.spectator) then
		P_SwitchShield(player, 1)
-- 		player.shieldstock = max(0,player.shieldmax)
		player.pity = 0
	end
end

B.OverlayHide = function(mo,owner)
	if not(owner and owner.valid) then return nil end
	if owner.flags&MF_NOCLIPTHING or owner.flags2&MF2_DONTDRAW then mo.flags2 = $|MF2_DONTDRAW return true
	else mo.flags2 = $&~MF2_DONTDRAW return false
	end
end
